local helper = wesnoth.require "lua/helper.lua"
_ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

-- music player manager
function tj_wml_jukebox_manager( var_musics, show_name )
  tamanegi_jukebox_gui_playlist_manager( var_musics, show_name )
end

function tj_wml_jukebox_manager3( var_musics1, show_name1,
                                  var_musics2, show_name2,
                                  var_musics3, show_name3 )
  tamanegi_jukebox_gui_playlist_manager3( var_musics1, show_name1,
                                          var_musics2, show_name2,
                                          var_musics3, show_name3 )
end

function tj_wml_jukebox_manager2( var_musics1, show_name1,
                                  var_musics2, show_name2 )
  tamanegi_jukebox_gui_playlist_manager2( var_musics1, show_name1,
                                          var_musics2, show_name2 )
end

-- player frontend
function tj_gui_jukebox( music_list )
  local choice = tamanegi_jukebox_gui_list( music_list )
  if choice >= 1 then
    wesnoth.music_list.play(music_list[choice].file)
    -- wesnoth.music_list.clear()
    -- wesnoth.music_list.add(music_list[choice].file, true )
    return true
  else
    return false
  end
end

function tj_gui_jukebox_play_next()
  wesnoth.music_list.next()
  return true
end

function tj_gui_jukebox_play_current()
  if #wesnoth.music_list > 0 then
    wesnoth.music_list.play(wesnoth.music_list.current.__cfg.name)
  end
  return true
end

function tj_gui_jukebox_play_previous()
  if #wesnoth.music_list > 0 then
    wesnoth.music_list.play(wesnoth.music_list.previous.__cfg.name)
  end
  return true
end

function tj_gui_jukebox_package()
  local optional = tamanegi_jukebox_check_optional()
  local done = false
  while done ~= true do
    local choice = tj_gui_choose_package()

    if choice == 0 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_core() ) then
        return true
      end
    elseif choice > 0 and choice < 13 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_umcbook( choice ) ) then
        return true
      end
    elseif choice == 13 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_wc1() ) then
        return true
      end
    elseif choice == 14 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_wc2() ) then
        return true
      end
    elseif choice == 15 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_whitewolf_pack() ) then
        return true
      end
    elseif choice == 16 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_asof_music() ) then
        return true
      end
    elseif choice == 17 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_archaic() ) then
        return true
      end
    elseif choice == 18 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_shadow_of_death() ) then
        return true
      end
    elseif choice == 19 then
      if tj_gui_jukebox( tamanegi_jukebox_get_table_jukebox_music() ) then
        return true
      end
    else
      return false
    end
  end
end

function tj_cui_add_track_to_var_byfname( var_musics, filename )
  local mylist = tamanegi_jukebox_get_all_music_list()
  for i = 1, #mylist do
    if mylist[i].file == filename then
      tamanegi_jukebox_utility_add_track( var_musics, mylist[i] )
      return
    end
  end
  -- not found, do nothing
end

function tj_cui_add_track_to_var( var_musics, booknum, index )
  local mylist = {}
  if booknum == 0 then
    mylist = tamanegi_jukebox_get_table_core()
  elseif booknum > 0 and booknum < 13 then
    mylist = tamanegi_jukebox_get_table_umcbook( booknum )
  elseif booknum == 13 then
    mylist = tamanegi_jukebox_get_table_wc1()
  elseif booknum == 14 then
    mylist = tamanegi_jukebox_get_table_wc2()
  elseif booknum == 15 then
    mylist = tamanegi_jukebox_get_table_whitewolf_pack()
  elseif booknum == 16 then
    mylist = tamanegi_jukebox_get_table_asof_music()
  elseif booknum == 17 then
    mylist = tamanegi_jukebox_get_table_archaic()
  elseif booknum == 18 then
    mylist = tamanegi_jukebox_get_table_shadow_of_death()
  elseif booknum == 19 then
    mylist = tamanegi_jukebox_get_table_jukebox_music()
  end
  if mylist ~= nil then
    if #mylist > 0 and #mylist >= index then
      tamanegi_jukebox_utility_add_track( var_musics, mylist[index] )
    end
  end
end

function tj_wml_get_music_from_core( var_ret, var_array_ret )
  local mylist = tamanegi_jukebox_get_table_core()
  local ret = tamanegi_jukebox_gui_list( mylist )
  if ret > 0 then
    wesnoth.set_variable( var_ret, "yes" )
    helper.set_variable_array( var_array_ret, mylist[ret] )
  else
    wesnoth.set_variable( var_ret, "no" )
  end
end

function tj_wml_get_music_from_umcbook( var_ret, var_array_ret, num )
  local mylist = tamanegi_jukebox_get_table_umcbook( num )
  local ret = tamanegi_jukebox_gui_list( mylist )
  if ret > 0 then
    wesnoth.set_variable( var_ret, "yes" )
    helper.set_variable_array( var_array_ret, mylist[ret] )
  else
    wesnoth.set_variable( var_ret, "no" )
  end
end

function tj_wml_get_all_music_list( var_array_ret )
  local mylist = tamanegi_jukebox_get_all_music_list()
  helper.set_variable_array( var_array_ret, mylist )
end

function tj_wml_get_core_music_list( var_array_ret )
  local mylist = tamanegi_jukebox_get_table_core()
  helper.set_variable_array( var_array_ret, mylist )
end

function tj_wml_get_umcbook_music_list( var_array_ret, num )
  local mylist = tamanegi_jukebox_get_table_umcbook( num )
  helper.set_variable_array( var_array_ret, mylist )
end

function tj_wml_get_west_chronicles_music_list( var_array_ret, num )
  if num == 1 then
    local mylist = tamanegi_jukebox_get_table_wc1()
    helper.set_variable_array( var_array_ret, mylist )
  elseif num == 2 then
    local mylist = tamanegi_jukebox_get_table_wc2()
    helper.set_variable_array( var_array_ret, mylist )
  end
end

--
-- functions below might be for internal use
--

-- check package
function tamanegi_jukebox_check_optional()
  local optional = { count     = 0,
                     UNDERNESS = false,
                     ASoF      = false,
                     ARCHAIC   = false,
                     SoDEATH   = false,
                     JMUSIC    = false
                   }
  -- Underness Series Music Pack (WhiteWolf Music Pack)
  if wesnoth.have_file( "~add-ons/WhiteWolf_Music_Pack/_main.cfg" ) then
    optional.UNDERNESS = true
    optional.count = optional.count + 1
  end
  -- A Song of Fire Music
  if wesnoth.have_file( "~add-ons/ASoF_Music/_main.cfg" ) then
    optional.ASoF = true
    optional.count = optional.count + 1
  end
  -- Archaic Sounds
  if wesnoth.have_file( "~add-ons/Archaic_Sounds/_main.cfg" ) then
    optional.ARCHAIC = true
    optional.count = optional.count + 1
  end
  -- The Shadow of Death music
  if wesnoth.have_file( "~add-ons/In_Shadow_music/_main.cfg" ) then
    optional.SoDEATH = true
    optional.count = optional.count + 1
  end
  -- Jukebox_Music
  if wesnoth.have_file( "~add-ons/Jukebox_Music/_main.cfg" ) then
    optional.JMUSIC = true
    optional.count = optional.count + 1
  end
  return optional
end

-- utility
function tamanegi_jukebox_utility_reset_playlist( var_musics )
  local music_list = helper.get_variable_array( var_musics )
  if music_list == nil or #music_list == 0 then
    return
  end
  local numbers = {}
  for i = 1, #music_list do
    numbers[i] = i
  end
  -- i'm afraid this shuffling does not make sense...
  helper.shuffle( numbers )
  for i = 1, #music_list do
    if i ~= 1 then
      wesnoth.music_list.add( music_list[numbers[i]].file )
    else
      wesnoth.music_list.clear()
      wesnoth.music_list.add( music_list[numbers[i]].file, true )
    end
  end
  -- wesnoth.music_list[#wesnoth.music_list].shuffle = false
end

function tamanegi_jukebox_utility_add_track( var_musics, track )
  local v = helper.get_variable_array( var_musics )
  if v ~= nil then
    local n = #v + 1
    v[n] = track
  else
    v[1] = track
  end
  helper.set_variable_array( var_musics, v )
end

-- gui
function tamanegi_jukebox_gui_playlist_manager( var_musics, show_name )
  _ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "choice", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Jukebox",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          border = "top,bottom",
          border_size = 10,
          T.label {
            id = "welcome_message",
            label = _"Welcome to the Music Player!",
            definition = "default_bold",
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from full list",
            return_value = 1,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from package",
            return_value = 2,
          }
        }
      },
      T.row {
        T.column {
          border = "top,bottom",
          border_size = 10,
          T.label {
            id = "current_message",
            label = tj_strip_path_and_ext(tj_current_music()),
            definition = "default_bold",
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play next track",
            return_value = 3,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Restart current track",
            return_value = 4,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play previous track",
            return_value = 5,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name,
            return_value = 10,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 20,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Quit Jukebox",
            return_value = 99,
          }
        }
      }
    }
  }

  -- nothind to do now
  function tamanegi_jukebox_gui_playlist_manager_preshow()
  end

  function tamanegi_jukebox_gui_playlist_manager_postshow()
  end

  local done = false
  while done ~= true do
    local choice = wesnoth.show_dialog( dialog, tamanegi_jukebox_gui_playlist_manager_preshow, tamanegi_jukebox_gui_playlist_manager_postshow )
    if choice == 1 then
      if tj_gui_jukebox( tamanegi_jukebox_get_all_music_list() ) then
        -- have to quit processing lua to play the selected music
        done = true
      end
    elseif choice == 2 then
      if tj_gui_jukebox_package() then
        done = true
      end
    elseif choice == 3 then
      if tj_gui_jukebox_play_next() then
        done = true
      end
    elseif choice == 4 then
      if tj_gui_jukebox_play_current() then
        done = true
      end
    elseif choice == 5 then
      if tj_gui_jukebox_play_previous() then
        done = true
      end
    elseif choice == 10 then
      tj_gui_jukebox_manager( var_musics, show_name )
      done = true
    else
      -- quit; everything done
      done = true
    end
  end
end

function tamanegi_jukebox_gui_playlist_manager2( var_musics1, show_name1,
                                                 var_musics2, show_name2 )
  _ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "choice", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Jukebox",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          border = "top,bottom",
          border_size = 10,
          T.label {
            id = "welcome_message",
            label = _"Welcome to the Music Player!",
            definition = "default_bold",
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from full list",
            return_value = 1,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from package",
            return_value = 2,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name1,
            return_value = 10,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name2,
            return_value = 11,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 20,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Quit Jukebox",
            return_value = 99,
          }
        }
      }
    }
  }

  -- nothind to do now
  function tamanegi_jukebox_gui_playlist_manager_preshow()
  end

  function tamanegi_jukebox_gui_playlist_manager_postshow()
  end

  local done = false
  while done ~= true do
    local choice = wesnoth.show_dialog( dialog, tamanegi_jukebox_gui_playlist_manager_preshow, tamanegi_jukebox_gui_playlist_manager_postshow )
    if choice == 1 then
      if tj_gui_jukebox( tamanegi_jukebox_get_all_music_list() ) then
        -- have to quit processing lua to play the selected music
        done = true
      end
    elseif choice == 2 then
      if tj_gui_jukebox_package() then
        done = true
      end
    elseif choice == 10 then
      tj_gui_jukebox_manager( var_musics1, show_name1 )
      done = true
    elseif choice == 11 then
      tj_gui_jukebox_manager( var_musics2, show_name2 )
      done = true
    else
      -- quit; everything done
      done = true
    end
  end
end

function tamanegi_jukebox_gui_playlist_manager3( var_musics1, show_name1,
                                                 var_musics2, show_name2,
                                                 var_musics3, show_name3 )
  _ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "choice", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Jukebox",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          border = "top,bottom",
          border_size = 10,
          T.label {
            id = "welcome_message",
            label = _"Welcome to the Music Player!",
            definition = "default_bold",
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from full list",
            return_value = 1,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Play a track: choose from package",
            return_value = 2,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name1,
            return_value = 10,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name2,
            return_value = 11,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Manage music list: " .. show_name3,
            return_value = 12,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 20,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Quit Jukebox",
            return_value = 99,
          }
        }
      }
    }
  }

  -- nothind to do now
  function tamanegi_jukebox_gui_playlist_manager_preshow()
  end

  function tamanegi_jukebox_gui_playlist_manager_postshow()
  end

  local done = false
  while done ~= true do
    local choice = wesnoth.show_dialog( dialog, tamanegi_jukebox_gui_playlist_manager_preshow, tamanegi_jukebox_gui_playlist_manager_postshow )
    if choice == 1 then
      if tj_gui_jukebox( tamanegi_jukebox_get_all_music_list() ) then
        -- have to quit processing lua to play the selected music
        done = true
      end
    elseif choice == 2 then
      if tj_gui_jukebox_package() then
        done = true
      end
    elseif choice == 10 then
      tj_gui_jukebox_manager( var_musics1, show_name1 )
      done = true
    elseif choice == 11 then
      tj_gui_jukebox_manager( var_musics2, show_name2 )
      done = true
    elseif choice == 12 then
      tj_gui_jukebox_manager( var_musics3, show_name3 )
      done = true
    else
      -- quit; everything done
      done = true
    end
  end
end

function tj_gui_jukebox_manager( var_musics, show_name )
  _ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "choice", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Jukebox:" .. show_name,
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          border = "top,bottom",
          border_size = 10,
          T.label {
            id = "welcome_message",
            label = _"Welcome to the Music Manager!",
            definition = "default_bold",
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"See current list",
            return_value = 1,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Add a track to a list: from full list",
            return_value = 2,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Add a track to a list: from package list",
            return_value = 3,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Add package to a list",
            return_value = 4,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 10,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Remove a track from the list",
            return_value = 11,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Remove all tracks from the list",
            return_value = 12,
          }
        }
      },
      T.row {
        T.column {
          border = "top",
          border_size = 20,
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Replace Music List to this one and Quit",
            return_value = 98,
          }
        }
      },
      T.row {
        T.column {
          T.button {
            linked_group = "choice",
            definition = "transparent",
            label = _"Quit Music Manager",
            return_value = 99,
          }
        }
      }
    }
  }

  function tj_gui_jukebox_manager_preshow()
  end

  function tj_gui_jukebox_manager_postshow()
  end

  local done = false
  local modified = false
  while done ~= true do
    local choice = wesnoth.show_dialog( dialog, tj_gui_jukebox_manager_preshow, tj_gui_jukebox_manager_postshow )
    if choice == 1 then
      local music_list = helper.get_variable_array( var_musics )
      if tj_gui_jukebox( music_list ) then
        if modified then
          tamanegi_jukebox_utility_reset_playlist( var_musics )
        end
        done = true
      end
    elseif choice == 2 then
      if tj_gui_jukebox_manager_add_from( var_musics, tamanegi_jukebox_get_all_music_list() ) then
        modified = true
      end
    elseif choice == 3 then
      if tj_gui_jukebox_manager_add_from_package( var_musics ) then
        modified = true
      end
    elseif choice == 4 then
      if tj_gui_jukebox_manager_add_all_from_package( var_musics ) then
        modified = true
      end
    elseif choice == 11 then
      if tj_gui_jukebox_manager_remove_track( var_musics ) then
        modified = true
      end
    elseif choice == 12 then
      if tj_gui_jukebox_manager_remove_all_tracks( var_musics ) then
        modified = true
      end
    elseif choice == 98 then
      tamanegi_jukebox_utility_reset_playlist( var_musics )
      done = true
    elseif choice == 99 then
      if modified then
        tamanegi_jukebox_utility_reset_playlist( var_musics )
      end
      done = true
    end
  end
end

function tj_gui_jukebox_manager_add_from( var_musics, music_list )
  local choice = tamanegi_jukebox_gui_list( music_list )
  if choice >= 1 then
    tamanegi_jukebox_utility_add_track( var_musics, music_list[choice] )
    return true
  end
  return false
end

function tj_gui_jukebox_manager_add_all_from( var_musics, music_list )
  for i=1,#music_list do
    tamanegi_jukebox_utility_add_track( var_musics, music_list[i] )
  end
  return true
end

function tj_gui_jukebox_manager_add_from_package( var_musics )
  local done = false
  while done ~= true do
    local pac = tj_gui_choose_package()
    if pac == 0 then
      local music_list = tamanegi_jukebox_get_table_core()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac > 0 and pac < 13 then
      local music_list = tamanegi_jukebox_get_table_umcbook( pac )
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 13 then
      local music_list = tamanegi_jukebox_get_table_wc1()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 14 then
      local music_list = tamanegi_jukebox_get_table_wc2()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 15 then
      local music_list = tamanegi_jukebox_get_table_whitewolf_pack()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 16 then
      local music_list = tamanegi_jukebox_get_table_asof_music()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 17 then
      local music_list = tamanegi_jukebox_get_table_archaic()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 18 then
      local music_list = tamanegi_jukebox_get_table_shadow_of_death()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 19 then
      local music_list = tamanegi_jukebox_get_table_jukebox_music()
      if tj_gui_jukebox_manager_add_from( var_musics, music_list ) then
        return true
      end
    else
      return false
    end
  end
end

function tj_gui_jukebox_manager_add_all_from_package( var_musics )
  local done = false
  while done ~= true do
    local pac = tj_gui_choose_package()
    if pac == 0 then
      local music_list = tamanegi_jukebox_get_table_core()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac > 0 and pac < 13 then
      local music_list = tamanegi_jukebox_get_table_umcbook( pac )
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 13 then
      local music_list = tamanegi_jukebox_get_table_wc1()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 14 then
      local music_list = tamanegi_jukebox_get_table_wc2()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 15 then
      local music_list = tamanegi_jukebox_get_table_whitewolf_pack()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 16 then
      local music_list = tamanegi_jukebox_get_table_asof_music()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 17 then
      local music_list = tamanegi_jukebox_get_table_archaic()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 18 then
      local music_list = tamanegi_jukebox_get_table_shadow_of_death()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    elseif pac == 19 then
      local music_list = tamanegi_jukebox_get_table_jukebox_music()
      if tj_gui_jukebox_manager_add_all_from( var_musics, music_list ) then
        return true
      end
    else
      return false
    end
  end
end

function tj_gui_jukebox_manager_remove_track( var_musics )
  local music_list = helper.get_variable_array( var_musics )
  local choice = tamanegi_jukebox_gui_list( music_list )
  if choice >= 1 then
    table.remove( music_list, choice )
    helper.set_variable_array( var_musics, music_list )
    return true
  end
  return false
end

function tj_gui_jukebox_manager_remove_all_tracks( var_musics )
  if tj_gui_dialog_yes_no( _"Remove all music tracks from the list?" ) then
    wesnoth.fire( "clear_variable", { name = var_musics } )
    return true
  end
  return false
end

function tj_gui_choose_package()
  local book = {}
  book[1] = tamanegi_jukebox_get_table_book1()
  book[2] = tamanegi_jukebox_get_table_book2()
  book[3] = tamanegi_jukebox_get_table_book3()
  book[4] = tamanegi_jukebox_get_table_book4()
  book[5] = tamanegi_jukebox_get_table_book5()
  book[6] = tamanegi_jukebox_get_table_book6()
  book[7] = tamanegi_jukebox_get_table_book7()
  book[8] = tamanegi_jukebox_get_table_book8()
  book[9] = tamanegi_jukebox_get_table_book9()
  book[10] = tamanegi_jukebox_get_table_book10()
  book[11] = tamanegi_jukebox_get_table_book11()
  book[12] = tamanegi_jukebox_get_table_book12()
  local wc = {}
  wc[1] = tamanegi_jukebox_get_table_wc1()
  wc[2] = tamanegi_jukebox_get_table_wc2()
  local other_umc = {}
  other_umc[0] = tamanegi_jukebox_get_table_whitewolf_pack()
  other_umc[1] = tamanegi_jukebox_get_table_asof_music()
  other_umc[2] = tamanegi_jukebox_get_table_archaic()
  other_umc[3] = tamanegi_jukebox_get_table_shadow_of_death()
  other_umc[4] = tamanegi_jukebox_get_table_jukebox_music()

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "package_choice", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Select Package",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          T.listbox {
            id = "package_selector",
            T.list_definition {
              T.row {
                T.column {
                  horizontal_grow = true,
                  vertical_grow = true,
                  T.toggle_panel {
                    definition = "default",
                    T.grid {
                      T.row {
                        T.column {
                          horizontal_grow = true,
                          border = "left,right",
                          border_size = 5,
                          T.label {
                            id = "package_name",
                            linked_group = "package_choice",
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      T.row {
        T.column {
          T.grid {
            T.row {
              T.column {
                T.button {
                  label = _"OK",
                  return_value = 1,
                }
              },
              T.column {
                T.button {
                  label = _"Cancel",
                  return_value = -1,
                }
              }
            }
          }
        }
      }
    }
  }

  function tj_gui_choose_package_preshow()
    wesnoth.set_dialog_value( _"Core package", "package_selector", 1, "package_name" )
    -- UMC Music Books
    for i = 1, 12 do
      if book[i] ~= nil and #book[i] > 0 then
        wesnoth.set_dialog_value( _"Book " .. i, "package_selector", i + 1, "package_name" )
      end
    end
    -- West's Chronicles
    if wesnoth.have_file( "~add-ons/Wests_Chronicles_I/_main.cfg" ) then
      wesnoth.set_dialog_value( _"West's Chronicles I", "package_selector", #book + 2, "package_name" )
    end
    if wesnoth.have_file( "~add-ons/Wests_Chronicles_II/_main.cfg" ) then
      wesnoth.set_dialog_value( _"West's Chronicles II", "package_selector", #book + 3, "package_name" )
    end
    -- WhiteWolf Music Pack
    if wesnoth.have_file( "~add-ons/WhiteWolf_Music_Pack/_main.cfg" ) then
      wesnoth.set_dialog_value( _"WhiteWolf Music Pack", "package_selector", #book + 4, "package_name" )
    end
    -- ASoF Music
    if wesnoth.have_file( "~add-ons/ASoF_Music/_main.cfg" ) then
      wesnoth.set_dialog_value( _"A Song of Fire Music", "package_selector", #book + 5, "package_name" )
    end
    -- Archaic Sounds
    if wesnoth.have_file( "~add-ons/Archaic_Sounds/_main.cfg" ) then
      wesnoth.set_dialog_value( _"Archaic Sounds", "package_selector", #book + 6, "package_name" )
    end
    -- The Shadow of Death music
    if wesnoth.have_file( "~add-ons/In_Shadow_music/_main.cfg" ) then
      wesnoth.set_dialog_value( _"The Shadow of Death music", "package_selector", #book + 7, "package_name" )
    end
    -- Jukebox_Music
    if wesnoth.have_file( "~add-ons/Jukebox_Music/_main.cfg" ) then
      wesnoth.set_dialog_value( _"Jukebox Music", "package_selector", #book + 8, "package_name" )
    else
      wesnoth.set_dialog_value( "", "package_selector", #book + 8, "package_name" )
    end
  end

  local package_chosen = -1
  function tj_gui_choose_package_postshow()
    package_chosen = wesnoth.get_dialog_value( "package_selector" )
  end

  local choice = wesnoth.show_dialog( dialog, tj_gui_choose_package_preshow, tj_gui_choose_package_postshow )
  if choice > 0 then
    package_chosen = package_chosen - 1
    return package_chosen
  end
  return -1
end

function tamanegi_jukebox_gui_list( music_list )
  local num = #music_list
  if num == 0 then
    return -1
  end

  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.linked_group { id = "music_title", fixed_width = true },
    T.linked_group { id = "music_author", fixed_width = true },
    T.linked_group { id = "music_file", fixed_width = true },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Choose Music Track",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          T.listbox {
            id = "music_chosen",
            T.header {
              T.row {
                T.column {
                  horizontal_grow = true,
                  border = "all",
                  border_size = 5,
                  T.label {
                    linked_group = "music_title",
                    label = _"Title",
                    definition = "default_bold",
                  }
                },
                T.column {
                  horizontal_grow = true,
                  border = "all",
                  border_size = 5,
                  T.label {
                    linked_group = "music_author",
                    label = _"Author",
                    definition = "default_bold",
                  }
                },
                T.column {
                  horizontal_grow = true,
                  border = "left,right",
                  border_size = 5,
                  T.label {
                    linked_group = "music_file",
                    label = _"Filename",
                    definition = "default_bold",
                  }
                }
              }
            },
            T.footer {
              T.row {
                T.column {
                  horizontal_grow = true,
                  border = "all",
                  border_size = 5,
                  T.label {
                    linked_group = "music_title",
                    label = _"Title",
                    definition = "default_bold",
                  }
                },
                T.column {
                  horizontal_grow = true,
                  border = "all",
                  border_size = 5,
                  T.label {
                    linked_group = "music_author",
                    label = _"Author",
                    definition = "default_bold",
                  }
                },
                T.column {
                  horizontal_grow = true,
                  border = "left,right",
                  border_size = 5,
                  T.label {
                    linked_group = "music_file",
                    label = _"Filename",
                    definition = "default_bold",
                  }
                }
              }
            },
            T.list_definition {
              T.row {
                T.column {
                  horizontal_grow = true,
                  vertical_grow = true,
                  T.toggle_panel {
                    definition = "default",
                    T.grid {
                      T.row {
                        T.column {
                          horizontal_grow = true,
                          border = "left,right",
                          border_size = 5,
                          T.label {
                            id = "music_title",
                            linked_group = "music_title",
                          }
                        },
                        T.column {
                          horizontal_grow = true,
                          border = "left,right",
                          border_size = 5,
                          T.label {
                            id = "music_author",
                            linked_group = "music_author",
                          }
                        },
                        T.column {
                          horizontal_grow = true,
                          border = "left,right",
                          border_size = 5,
                          T.label {
                            id = "music_file",
                            linked_group = "music_file",
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      T.row {
        T.column {
          T.grid {
            T.row {
              T.column {
                T.button {
                  label = _"OK",
                  return_value = 1,
                }
              },
              T.column {
                T.button {
                  label = _"Cancel",
                  return_value = -1,
                }
              }
            }
          }
        }
      }
    }
  }

  function tamanegi_jukebox_gui_list_preshow()
    for i = 1, #music_list do
      wesnoth.set_dialog_value( music_list[i].title, "music_chosen", i, "music_title" )
      wesnoth.set_dialog_value( music_list[i].author, "music_chosen", i, "music_author" )
      wesnoth.set_dialog_value( music_list[i].file, "music_chosen", i, "music_file" )
    end
  end

  local music_chosen = -1
  function tamanegi_jukebox_gui_list_postshow()
    music_chosen = wesnoth.get_dialog_value( "music_chosen" )
  end

  local choice = wesnoth.show_dialog( dialog, tamanegi_jukebox_gui_list_preshow, tamanegi_jukebox_gui_list_postshow )
  if choice > 0 then
    return music_chosen
  else
    return 0
  end
end

function tj_gui_dialog_yes_no( message )
  local T = wml.tag
  local dialog = {
    definition = "message",
    click_dismiss = false,

    T.tooltip { id = "tooltip_large" },
    T.helptip { id = "tooltip_large" },

    T.grid {
      T.row {
        T.column {
          T.label {
            id = "title",
            label = _"Inquiry",
            definition = "title",
          }
        }
      },
      T.row {
        T.column {
          T.grid {
            T.row {
              T.column {
                T.label {
                  label = message,
                  definition = "default",
                }
              }
            }
          }
        }
      },
      T.row {
        T.column {
          T.grid {
            T.row {
              T.column {
                T.button {
                  label = _"OK",
                  return_value = 1,
                }
              },
              T.column {
                T.button {
                  label = _"Cancel",
                  return_value = -1,
                }
              }
            }
          }
        }
      }
    }
  }

  function tj_gui_dialog_yes_no_preshow()
  end

  function tj_gui_dialog_yes_no_postshow()
  end

  local choice = wesnoth.show_dialog( dialog, tj_gui_dialog_yes_no_preshow, tj_gui_dialog_yes_no_postshow )
  if choice == 1 then
    return true
  end
  return false
end

-- data

-- create music list and return it
function tamanegi_jukebox_get_all_music_list()
  -- metatable for table concat
  local T = {}
  T.__concat = function( x, y )
    local ret = {}
    for i,_ in ipairs(x) do
      table.insert( ret, x[i] )
    end
    for i,_ in ipairs(y) do
      table.insert( ret, y[i] )
    end
    return ret
  end

  local ret = tamanegi_jukebox_get_table_core()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book1()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book2()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book3()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book4()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book5()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book6()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book7()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book8()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book9()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book10()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book11()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_book12()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_wc1()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_wc2()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_whitewolf_pack()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_asof_music()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_archaic()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_shadow_of_death()
  setmetatable( ret, T )
  ret = ret .. tamanegi_jukebox_get_table_jukebox_music()

  return ret
end

-- music title priorities
-- 0. official name (maybe specific for core musics)
-- 1. the title embedded in the file
--    + strings might be version names such as v2 and v4 will be ignored
--    + capitalized
--    + underscore is replaced by space
-- 2. title described in the _main.cfg of UMC Music Book

-- core musics
function tamanegi_jukebox_get_table_core()
  local path = "core/music/"
  local ret = {}
  if wesnoth.have_file( path ) then
    -- Doug Kaufman = dkaufman
    -- Aleksi Aubry-Carlson = Aleksi
    -- Mattias Westlund = West
    -- Tyler Johnson = Tyler Johnson
    -- Timothy Pinkham = TimothyP
    -- Ryan Reilly = Rain
    -- Joseph G. Toscano = Zhaytee
    -- Jeremy Nicoll = jeremy2
    -- Gianmarco Leone = gmlion
    ret[1] = { file   = "battle-epic.ogg",
               title  = _"Battle Epic",
               author = "dkaufman" }
    ret[2] = { file   = "battle.ogg",
               title  = _"Battle Music",
               author = "Aleksi" }
    ret[3] = { file   = "breaking_the_chains.ogg",
               title  = _"Breaking the Chains",
               author = "West" }
    ret[4] = { file   = "casualties_of_war.ogg",
               title  = _"Casualties of War",
               author = "Tyler Johnson" }
    ret[5] = { file   = "defeat.ogg",
               title  = _"Defeat",
               author = "TimothyP" }
    ret[6] = { file   = "defeat2.ogg",
               title  = _"Defeat",
               author = "Rain" }
    ret[7] = { file   = "elf-land.ogg",
               title  = _"Elf Land",
               author = "Aleksi" }
    ret[8] = { file   = "elvish-theme.ogg",
               title  = _"Elvish Theme",
               author = "dkaufman" }
    ret[9] = { file   = "frantic-old.ogg",
               title  = _"Frantic",
               author = "Aleksi" }
    ret[10] = { file   = "frantic.ogg",
               title  = _"Frantic",
               author = "TreizeCouleurs" }
    ret[11] = { file   = "heroes_rite.ogg",
                title  = _"Heroes' Rite",
                author = "dkaufman" }
    ret[12] = { file   = "into_the_shadows.ogg",
                title  = _"Into the Shadows",
                author = "Tyler Johnson" }
    ret[13] = { file   = "journeys_end.ogg",
                title  = _"Journey's End",
                author = "West" }
    ret[14] = { file   = "knalgan_theme.ogg",
                title  = _"Knalgan Theme",
                author = "Rain" }
    ret[15] = { file   = "knolls.ogg",
                title  = _"The Knolls of Doldesh",
                author = "TimothyP" }
    ret[16] = { file   = "legends_of_the_north.ogg",
                title  = _"Legends of the North",
                author = "West" }
    ret[17] = { file   = "love_theme.ogg",
                title  = _"Love Theme",
                author = "Rain" }
    ret[18] = { file   = "loyalists.ogg",
                title  = _"Loyalists",
                author = "Zhaytee" }
    ret[19] = { file   = "main_menu.ogg",
                title  = _"Main Theme",
                author = "Aleksi" }
    ret[20] = { file   = "northern_mountains.ogg",
                title  = _"Over the Northern Mountains",
                author = "West" }
    ret[21] = { file   = "northerners.ogg",
                title  = _"Northerners",
                author = "Aleksi" }
    ret[22] = { file   = "nunc_dimittis.ogg",
                title  = _"Nunc Dimittis",
                author = "jeremy2" }
    ret[23] = { file   = "return_to_wesnoth.ogg",
                title  = _"Return to Wesnoth",
                author = "West" }
    ret[24] = { file   = "revelation.ogg",
                title  = _"Revelation",
                author = "Zhaytee" }
    ret[25] = { file   = "sad.ogg",
                title  = _"Sad",
                author = "Tyler Johnson" }
    ret[26] = { file   = "siege_of_laurelmor.ogg",
                title  = _"Siege of Laurelmor",
                author = "dkaufman" }
    ret[27] = { file   = "silence.ogg",
                title  = _"Silence",
                author = "?" }
    ret[28] = { file   = "silvan_sanctuary.ogg",
                title  = _"Silvan Sanctuary",
                author = "West" }
    ret[29] = { file   = "suspense.ogg",
                title  = _"Suspense",
                author = "Rain" }
    ret[30] = { file   = "the_city_falls.ogg",
                title  = _"The City Falls",
                author = "dkaufman" }
    ret[31] = { file   = "the_dangerous_symphony.ogg",
                title  = _"The Dangerous Symphony",
                author = "gmlion" }
    ret[32] = { file   = "the_deep_path.ogg",
                title  = _"The Deep Path",
                author = "gmlion" }
    ret[33] = { file   = "the_king_is_dead.ogg",
                title  = _"The King is Dead",
                author = "West" }
    ret[34] = { file   = "transience.ogg",
                title  = _"Transience",
                author = "Aleksi" }
    ret[35] = { file   = "traveling_minstrels.ogg",
                title  = _"Traveling Minstrels",
                author = "West" }
    ret[36] = { file   = "underground.ogg",
                title  = _"Underground",
                author = "Aleksi" }
    ret[37] = { file   = "vengeful.ogg",
                title  = _"Vengeful Pursuit",
                author = "jeremy2" }
    ret[38] = { file   = "victory.ogg",
                title  = _"Victory",
                author = "TimothyP" }
    ret[39] = { file   = "victory2.ogg",
                title  = _"Victory",
                author = "Rain" }
    ret[40] = { file   = "wanderer.ogg",
                title  = _"Still Another Wanderer",
                author = "TimothyP" }
    ret[41] = { file   = "weight_of_revenge.ogg",
                title  = _"Weight of Revenge",
                author = "dkaufman" }
  end
  return ret
end

function tamanegi_jukebox_get_table_umcbook( num )
  local myswitch = {}
  myswitch[1] = tamanegi_jukebox_get_table_book1
  myswitch[2] = tamanegi_jukebox_get_table_book2
  myswitch[3] = tamanegi_jukebox_get_table_book3
  myswitch[4] = tamanegi_jukebox_get_table_book4
  myswitch[5] = tamanegi_jukebox_get_table_book5
  myswitch[6] = tamanegi_jukebox_get_table_book6
  myswitch[7] = tamanegi_jukebox_get_table_book7
  myswitch[8] = tamanegi_jukebox_get_table_book8
  myswitch[9] = tamanegi_jukebox_get_table_book9
  myswitch[10] = tamanegi_jukebox_get_table_book10
  myswitch[11] = tamanegi_jukebox_get_table_book11
  myswitch[12] = tamanegi_jukebox_get_table_book12

  return myswitch[num]()
end

-- we should check whether file exists for non-core packages
function tamanegi_jukebox_add_track( table_data, mpath, filedata )
  if wesnoth.have_file( mpath .. filedata.file ) then
    table.insert( table_data, filedata )
  else
    print( "ERROR, file:" .. mpath .. filedata.file .. " is missing." )
  end
end

-- UMC Music Books
function tamanegi_jukebox_get_table_book1()
  local path = "~add-ons/UMC_Music_Book_01/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_01/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a3deap_DontFearTheReaper.ogg",
                                  title  = _"Don't Fear The Reaper",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a3deap_GoForTheWorldAgain.ogg",
                                  title  = _"Go for the World Again",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a3deap_HighInTheMountains.ogg",
                                  title  = _"High in the Mountains",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a3deap_HoistTheColours.ogg",
                                  title  = _"Hoist the Colors",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "battlecry.ogg",
                                  title  = _"Battle Cry",
                                  author = "ancestral" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "calm-before-storm.ogg",
                                  title  = _"Calm Before the Storm",
                                  author = "Tlogmer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "gameplay06.ogg",
                                  title  = _"Game Play 06",
                                  author = "Aleksi" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "snowfall.ogg",
                                  title  = _"Lonely Snowfall",
                                  author = "jeremy2" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "tribal_war_song.ogg",
                                  title  = _"Primitive War Song",
                                  author = "hiro hito" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book2()
  local path = "~add-ons/UMC_Music_Book_02/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_02/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "City_of_Dwarves.ogg",
                                  title  = _"City of Dwarves",
                                  author = "Nickolay" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ElvenDance.ogg",
                                  title  = _"Elven Dance",
                                  author = "pph" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Stella_Splendens.ogg",
                                  title  = _"Stella Splendens",
                                  author = "Nickolay" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Through_the_Woodlands.ogg",
                                  title  = _"Through the Woodlands",
                                  author = "Ewing" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Triumph.ogg",
                                  title  = _"Triumph",
                                  author = "Nickolay" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "alternative.ogg",
                                  title  = _"Transience Alt",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_1.ogg",
                                  title  = _"Ambient Loop 1",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_2.ogg",
                                  title  = _"Ambient Loop 2",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_3.ogg",
                                  title  = _"Ambient Loop 3",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_4.ogg",
                                  title  = _"Ambient Loop 4",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_5.ogg",
                                  title  = _"Ambient Loop 5",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_6.ogg",
                                  title  = _"Ambient Loop 6",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_7.ogg",
                                  title  = _"Ambient Loop 7",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambient_loop_8.ogg",
                                  title  = _"Ambient Loop 8",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "blank.ogg",
                                  title  = _"Blank",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "northerners-old.ogg",
                                  title  = _"Northerners",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth-3.ogg",
                                  title  = _"Wesnoth 3",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth-4.ogg",
                                  title  = _"Wesnoth 4",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth-6.ogg",
                                  title  = _"Wesnoth 6",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth-7.ogg",
                                  title  = _"Wesnoth 7",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth-8.ogg",
                                  title  = _"Wesnoth 8",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth_final_draft.ogg",
                                  title  = _"Wesnoth Final Draft",
                                  author = "CheeseLord" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book3()
  local path = "~add-ons/UMC_Music_Book_03/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_03/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "A_Call_To_Arms.ogg",
                                  title  = _"A Call To Arms",
                                  author = "soundandfury" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "A_Silver_Wind.ogg",
                                  title  = _"A Silver Wind",
                                  author = "IoN" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Final.ogg",
                                  title  = _"Final",
                                  author = "charly" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "In_the_Land_of_Madness.ogg",
                                  title  = _"In The Land Of Madness",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "New_Wesnoth_Battle_Music.ogg",
                                  title  = _"PS Sewers Battle Theme 5",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "One_Thousand_Suns.ogg",
                                  title  = _"One Thousand Suns",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Skeleton_Dance.ogg",
                                  title  = _"Skeleton Dance",
                                  author = "soundandfury" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "The_Gathering_Storm.ogg",
                                  title  = _"The Gathering Storm",
                                  author = "Ewing" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Upon_Green_Hills.ogg",
                                  title  = _"Upon Green Hills",
                                  author = "soundandfury" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "homeward_bound.ogg",
                                  title  = _"Homeward Bound",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "the_high_kings_march.ogg",
                                  title  = _"The High King's March",
                                  author = "West" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book4()
  local path = "~add-ons/UMC_Music_Book_04/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_04/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Battalions.ogg",
                                  title  = _"Battalions",
                                  author = "Jarkko" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "BattleLoop.ogg",
                                  title  = _"Battle Loop",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Battle_Hymn_of_Wesnoth.ogg",
                                  title  = _"Battle Hymn of Wesnoth",
                                  author = "azrael1322" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Broken_Truth.ogg",
                                  title  = _"Broken Truth",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Elfs.ogg",
                                  title  = _"Elfs",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Enchanted_Forest.ogg",
                                  title  = _"Enchanted Forest",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Everlasting_Night.ogg",
                                  title  = _"Everlasting Night",
                                  author = "Murilo Carvalho" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "FranticSketch.ogg",
                                  title  = _"Frantic Sketch",
                                  author = "TreizeCouleurs" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "HeroDead.ogg",
                                  title  = _"Hero Dead",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Peaceful.ogg",
                                  title  = _"Peaceful",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Victorious.ogg",
                                  title  = _"Victorious",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "War_Glory.ogg",
                                  title  = _"War Glory",
                                  author = "Parduz" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "death_march.ogg",
                                  title  = _"Death March",
                                  author = "Spi" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "tekkno-03.ogg",
                                  title  = _"Tekkno 03",
                                  author = "azrael1322" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book5()
  local path = "~add-ons/UMC_Music_Book_05/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_05/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Etherea.ogg",
                                  title  = _"Etherea",
                                  author = "ragesoss" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Facing_the_Front.ogg",
                                  title  = _"Facing the Front",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "First-midquality.ogg",
                                  title  = _"First-midquality",
                                  author = "Swift" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "LoveTheme.ogg",
                                  title  = _"Love Theme",
                                  author = "sur.nhm" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Theme01.ogg",
                                  title  = _"Theme01",
                                  author = "Aibohphobia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Thoughts.ogg",
                                  title  = _"Thoughts",
                                  author = "Swift" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Wesnoth.ogg",
                                  title  = _"Wesnoth",
                                  author = "SpoOkyMagician" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "WesnothForTheOrcs.ogg",
                                  title  = _"Wesnoth theme for the orcs",
                                  author = "xolodilnikus" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Wesnothv5.ogg",
                                  title  = _"Wesnoth v5",
                                  author = "mus0" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "battle_theme.ogg",
                                  title  = _"Battle Theme",
                                  author = "Elemental" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "fallen_friend.ogg",
                                  title  = _"Fallen Friend",
                                  author = "Zajoman" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "gameplay_theme.ogg",
                                  title  = _"Gameplay Theme",
                                  author = "marcusvinius" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "maabad16.ogg",
                                  title  = _"Maabad16",
                                  author = "barisurum" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnothEWClar.ogg",
                                  title  = _"Wesnoth EW Clar",
                                  author = "pph" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book6()
  local path = "~add-ons/UMC_Music_Book_06/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_06/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Breeze.ogg",
                                  title  = _"Breeze",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "HighlanderWarDrums.ogg",
                                  title  = _"Highlander Battle Drums",
                                  author = "Velensk" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Loyalist_Loss_Cello.ogg",
                                  title  = _"Loyalist Loss Cello",
                                  author = "ryn" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Loyalist_Loss_Piano.ogg",
                                  title  = _"Loyalist Loss Piano",
                                  author = "ryn" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "LunarCage.ogg",
                                  title  = _"Lunar Cage",
                                  author = "AngeloB" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "March_of_the_divine.ogg",
                                  title  = _"March of the Divine",
                                  author = "greatsaiamanz@hotmail.com" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Tarhensis_Theme.ogg",
                                  title  = _"Tarhensis Theme",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "UNDEAD.ogg",
                                  title  = _"UNDEAD",
                                  author = "Industriebrot" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Wesn.ogg",
                                  title  = _"Wesn",
                                  author = "Industriebrot" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Wesnoth_Horn.ogg",
                                  title  = _"Wesnoth Horn",
                                  author = "azrael1322" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "beforethisbattle.ogg",
                                  title  = _"Before This Battle",
                                  author = "amilcare" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "defeat_ending_adventures.ogg",
                                  title  = _"Defeat Ending Adventures",
                                  author = "amilcare" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "defeattheme.ogg",
                                  title  = _"Defeat Theme",
                                  author = "Gandledorf" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "intro.ogg",
                                  title  = _"Intro",
                                  author = "amilcare" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "music_score.ogg",
                                  title  = _"Wesnoth score",
                                  author = "dkaufman" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "presentation.ogg",
                                  title  = _"Presentation",
                                  author = "amilcare" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "victorytheme.ogg",
                                  title  = _"Victory Theme",
                                  author = "Gandledorf" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book7()
  local path = "~add-ons/UMC_Music_Book_07/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_07/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Drums_of_War.ogg",
                                  title  = _"Drums of War",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Farewell.ogg",
                                  title  = _"Farewell",
                                  author = "artisticdude" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Layers_of_Harmony.ogg",
                                  title  = _"Layers of Harmony",
                                  author = "TheDreamer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "New_Thingy.ogg",
                                  title  = _"New Thingy",
                                  author = "[PA] NotUncleDave" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Pantest.ogg",
                                  title  = _"Pantest",
                                  author = "Skizzaltix" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Short_Sequence.ogg",
                                  title  = _"Short Sequence",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "The_Fazzemer_Theme.ogg",
                                  title  = _"The Fazzemer Theme (Demo Reel)",
                                  author = "CheeseLord" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Tide_of_Battle.ogg",
                                  title  = _"Tide of Battle",
                                  author = "bobbachy" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "after_full_moon_piano.ogg",
                                  title  = _"After Full Moon",
                                  author = "Erik Rijshouwer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambuscade.ogg",
                                  title  = _"Ambuscade",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "besieged.ogg",
                                  title  = _"Besieged",
                                  author = "ancestral" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "bubblegum.ogg",
                                  title  = _"I CAN HAZ BUBBLEGUM?",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "dark_passage.ogg",
                                  title  = _"Dark Passage",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "exploration.ogg",
                                  title  = _"Exploration",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "hail_to_the_cheese.ogg",
                                  title  = _"Hail to the Cheese",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "loyalists10.ogg",
                                  title  = _"Loyalists 10",
                                  author = "Spi" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "milk_and_cookies.ogg",
                                  title  = _"Milk and Cookies",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "sing.ogg",
                                  title  = _"Sing",
                                  author = "marcusvinicius" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "sir_rupert.ogg",
                                  title  = _"Sir Rupert the Chaste",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "space_marines.ogg",
                                  title  = _"Space Marines!",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "tadpole.ogg",
                                  title  = _"The Journeys of St. Tadpole",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "tedium.ogg",
                                  title  = _"Tedium in G minor",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth_song1.ogg",
                                  title  = _"Wesnoth Song",
                                  author = "Jarkko" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book8()
  local path = "~add-ons/UMC_Music_Book_08/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_08/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "A_Land_of_Adventure.ogg",
                                  title  = _"A Land of Adventure",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Adventure_Theme.ogg",
                                  title  = _"Adventure Theme",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Climactic_Contemplation.ogg",
                                  title  = _"Climactic Contemplation",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Epic_Race.ogg",
                                  title  = _"Epic Race",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Far_to_fly.ogg",
                                  title  = _"Far to Fly",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Forested_Vista.ogg",
                                  title  = _"Forested Vista",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Leave_none_alive.ogg",
                                  title  = _"Leave None Alive",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "MoleMan.ogg",
                                  title  = _"MoleMan",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "figght.ogg",
                                  title  = _"Figght",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "flanger.ogg",
                                  title  = _"Flanger",
                                  author = "Nick Humphrey" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "fragments_of_time_cut.ogg",
                                  title  = _"Fragments of Time (Cut)",
                                  author = "Erik Rijshouwer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "old_english_march.ogg",
                                  title  = _"Old English March",
                                  author = "Nick Humphrey" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "reunion.ogg",
                                  title  = _"Reunion",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "strings_wings_and_things.ogg",
                                  title  = _"Strings And Wings And Things",
                                  author = "Nick Humphrey" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "the_silver_tree.ogg",
                                  title  = _"The Silver Tree",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "theme_of_a_new_order.ogg",
                                  title  = _"A New Order Theme",
                                  author = "Christian Hellerberg" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "through_the_gates.ogg",
                                  title  = _"Through the Gates",
                                  author = "?" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book9()
  local path = "~add-ons/UMC_Music_Book_09/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_09/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Exploration_T.ogg",
                                  title  = _"Exploration T",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "No_name.ogg",
                                  title  = _"No Name",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Overlive.ogg",
                                  title  = _"Overlive",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Prologue.ogg",
                                  title  = _"Prologue",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Regular_Battle.ogg",
                                  title  = _"Regular Battle",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Returning_in_Time.ogg",
                                  title  = _"Returning in Time",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Run2.ogg",
                                  title  = _"Run2",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Ship_from_the_FogV1.ogg",
                                  title  = _"Ship From The Fog V1",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Snow_on_a_Castle.ogg",
                                  title  = _"Snow on a Castle",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Terradorians_Theme_Song.ogg",
                                  title  = _"Terradorians Theme Song",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "The_Kings_Crowning_V1.ogg",
                                  title  = _"The King's Crowning V1",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "The_Passing_of_an_Age.ogg",
                                  title  = _"The Passing of an Age",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "WIP_Fast_Paced_Theme.ogg",
                                  title  = _"Fast Paced Theme",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Western_Theme2.ogg",
                                  title  = _"Western Theme 2",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Zedarian_Theme.ogg",
                                  title  = _"Zedarian Theme",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "brwydr.ogg",
                                  title  = _"Brwydr",
                                  author = "Theodin" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book10()
  local path = "~add-ons/UMC_Music_Book_10/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_10/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "3rd.ogg",
                                  title  = "?",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Arkenstoned.ogg",
                                  title  = _"Arkenstoned",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Camel_Soup.ogg",
                                  title  = _"Camel Soup",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Flight_of_the_Drakes.ogg",
                                  title  = _"Flight of the Drakes",
                                  author = "[PA]NotUncleDave" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Merry_Monsters.ogg",
                                  title  = _"Merry Monsters",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Scurvy_Dogs_Yarr.ogg",
                                  title  = _"Scurvy Dogs, Yarr!",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "The_Longest_Night.ogg",
                                  title  = _"The Longest Night",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "To_Pee_or_not_to_Pee.ogg",
                                  title  = _"To Pee or not to Pee",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Toad_Stool.ogg",
                                  title  = _"Toad Stool",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Trite_And_Wrong.ogg",
                                  title  = _"Trite and Wrong",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "acherontic.ogg",
                                  title  = _"Acherontic",
                                  author = "x42" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "harp.ogg",
                                  title  = "?",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "overland_1.ogg",
                                  title  = "?",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "overland_2.ogg",
                                  title  = "?",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "solstice.ogg",
                                  title  = _"Solstice (WIP)",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "zhaytee_tragedy.ogg",
                                  title  = _"Tragedy",
                                  author = "ZhayTee?" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book11()
  local path = "~add-ons/UMC_Music_Book_11/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_11/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Army_Theme.ogg",
                                  title  = _"Army Theme",
                                  author = "Axfinger" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "BuildingEvil.ogg",
                                  title  = _"BuildingEvil",
                                  author = "Axfinger" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Flight_Theme.ogg",
                                  title  = _"Flight Theme",
                                  author = "Axfinger" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "LunaTower.ogg",
                                  title  = _"Luna Tower",
                                  author = "Axfinger" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Three_Marimbas.ogg",
                                  title  = _"Three Marimbas",
                                  author = "willis" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Undeady_Waltzery.ogg",
                                  title  = _"Undeady Waltzery",
                                  author = "Lipk" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Vibes.ogg",
                                  title  = _"Vibes Theme",
                                  author = "Axfinger" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a_distant_land.ogg",
                                  title  = _"A Distant Land",
                                  author = "willis" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "bitter_fate_acc.ogg",
                                  title  = _"Bitter Fate Acc",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "bitter_fate_v2.ogg",
                                  title  = _"Bitter Fate V2",
                                  author = "iceiceice" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "filk.ogg",
                                  title  = _"Filk",
                                  author = "willis" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ice_drake3b.ogg",
                                  title  = _"Ice Drake 3B",
                                  author = "aquileia/iceiceice" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "lament.ogg",
                                  title  = _"Lament",
                                  author = "willis" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "light.ogg",
                                  title  = _"Light",
                                  author = "willis" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif1.ogg",
                                  title  = _"Motif 1",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif11_cello.ogg",
                                  title  = _"Motif 11 Cello",
                                  author = "aquileia/iceiceice" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif12.ogg",
                                  title  = _"Motif 12",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif14.ogg",
                                  title  = _"Motif 14",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif15_battering_ram.ogg",
                                  title  = _"Battering Ram (Motif 15)",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif17_fiery_lungs.ogg",
                                  title  = _"Fiery Lungs (Motif 17)",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif3.ogg",
                                  title  = _"Motif 3",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif7.ogg",
                                  title  = _"Motif 7",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif9.ogg",
                                  title  = _"Motif 9",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "myjourney.ogg",
                                  title  = _"My Journey",
                                  author = "willis" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_book12()
  local path = "~add-ons/UMC_Music_Book_12/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/UMC_Music_Book_12/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "CryFromElensefar.ogg",
                                  title  = _"Cry From Elensefar",
                                  author = "Pluft" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "elegy.ogg",
                                  title  = _"Elegy",
                                  author = "krb" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif18.ogg",
                                  title  = _"Motif 18",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif20.ogg",
                                  title  = _"Motif 20",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "motif21.ogg",
                                  title  = _"Motif 21",
                                  author = "aquileia" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "zhaytee_fanfare.ogg",
                                  title  = _"Fanfare",
                                  author = "ZhayTee" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "zhaytee_lovetheme.ogg",
                                  title  = _"Love Theme",
                                  author = "ZhayTee" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "zhaytee_newtruths.ogg",
                                  title  = _"New Truths",
                                  author = "ZhayTee" } )
  end
  return ret
end

---- template
--function tamanegi_jukebox_get_table_book()
--  local path = "~add-ons/UMC_Music_Book_/_main.cfg"
--  local ret = {}
--  if wesnoth.have_file( path ) then
--    local music_path = "~add-ons/UMC_Music_Book_/music/"
--  end
--  return ret
--end

function tamanegi_jukebox_get_table_wc1()
  local path = "~add-ons/Wests_Chronicles_I/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/Wests_Chronicles_I/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "1_Blood_Winter.ogg",
                                  title  = _"Blood Winter",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "2_Gwendolyn.ogg",
                                  title  = _"Gwendolyn",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "3_March_of_the_Silver_Dragon.ogg",
                                  title  = _"March of the Silver Dragon",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "4_The_Forging_of_Souls.ogg",
                                  title  = _"The Forging of Souls",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "5_Into_Aer_Cumri.ogg",
                                  title  = _"Into Aer Cumri",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "6_The_Battle_of_Gavelburg.ogg",
                                  title  = _"The Battle of Gavelburg",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "7_Gwendolyns_Death.ogg",
                                  title  = _"Gwendolyn's Death",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "8_The_Death_of_Magic.ogg",
                                  title  = _"The Death of Magic",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "9_Farewells_at_the_Edge_of_the_World.ogg",
                                  title  = _"Farewells at the Edge of the World",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "10_Epic_Voyage.ogg",
                                  title  = _"Epic Voyage",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "11_The_Barbarian_Host.ogg",
                                  title  = _"The Barbarian Host",
                                  author = "West" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_wc2()
  local path = "~add-ons/Wests_Chronicles_II/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/Wests_Chronicles_II/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "1_Heroes.ogg",
                                  title  = _"Heroes",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "2_Gol_Ashamdir.ogg",
                                  title  = _"Gol Ashamdir",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "3_Celtic_Groove.ogg",
                                  title  = _"Celtic Groove",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "4_Desert_Chase.ogg",
                                  title  = _"Desert Chase",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "5_Isanbar_Theme.ogg",
                                  title  = _"Isanbar Theme",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "6_East_Meets_West.ogg",
                                  title  = _"East Meets West",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "7_Before_the_Battle.ogg",
                                  title  = _"Before the Battle",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "8_Springtime.ogg",
                                  title  = _"Springtime",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "9_The_Shining_City.ogg",
                                  title  = _"The Shining City",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "10_Ruins.ogg",
                                  title  = _"Ruins",
                                  author = "West" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_whitewolf_pack()
  local path = "~add-ons/WhiteWolf_Music_Pack/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/WhiteWolf_Music_Pack/music/"
    -- SuperTux2
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "darkforestkeep.ogg",
                                  title  = _"Dark Forest Keep",
                                  author = "Wansti" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "fortress.ogg",
                                  title  = _"Fortress",
                                  author = "Wansti" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wisphunt.ogg",
                                  title  = _"Wisphunt",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "greatgigantic.ogg",
                                  title  = _"The Great Gigantic Secret",
                                  author = "Wansti with permission of Chris Huelsbeck" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "clavelian_march.ogg",
                                  title  = _"Clavelian March",
                                  author = "Bergebakken" } )
    if not wesnoth.have_file( "~add-ons/UMC_Music_Book_05/_main.cfg" ) then
      -- filename conflict
      -- UMC Music Book one might be prior
      tamanegi_jukebox_add_track( ret, music_path,
                                  { file   = "battle_theme.ogg",
                                    title  = _"Battle Theme",
                                    author = "remaxim" } )
    end
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "bossattack.ogg",
                                  title  = _"Boss Attack",
                                  author = "Wansti" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "airship_remix.ogg",
                                  title  = _"Airship song remix",
                                  author = "Bart Kelsey" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ghostforest.ogg",
                                  title  = _"Ghost Forest",
                                  author = "Wansti" } )
    -- Wesnoth
    -- duplicate (against UMC Book02; filename is different)
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "alt_T.mp3",
                                  title  = _"Transience Alt",
                                  author = "CheeseLord" } )
    -- duplicate (against UMC Book03; filename is different)
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "gathering_storm.mp3",
                                  title  = _"Gathering Storm",
                                  author = "Ewing" } )
    -- Widelands
    if not wesnoth.have_file( "~add-ons/ASoF_Music/_main.cfg" ) then
      -- filename conflict (ASoF Music)
      tamanegi_jukebox_add_track( ret, music_path,
                                  { file   = "end.ogg",
                                    title  = "?",
                                    author = "(from GPLed game Widelands)" } )
    end
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "intro_00.ogg",
                                  title  = "?",
                                  author = "(from GPLed game Widelands)" } )
    -- ?
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "horror.ogg",
                                  title  = "?",
                                  author = "?" } )
    -- EpicMucic
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "heroes_march.ogg",
                                  title  = _"Heroes March",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "journey_to_the_east.ogg",
                                  title  = _"Journey to the East",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "lost_and_forgotten.ogg",
                                  title  = _"Lost and Forgotten",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "raindrops_of_a_dream.ogg",
                                  title  = _"Raindrops of a Dream",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "searching.ogg",
                                  title  = _"searching",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "sisters_of_snow_dissent.ogg",
                                  title  = _"Sisters of Snow Dissent",
                                  author = "(from EpicMusic)" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "travels_to_the_east.ogg",
                                  title  = _"Travels to the East",
                                  author = "(from EpicMusic)" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_asof_music()
  local path = "~add-ons/ASoF_Music/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/ASoF_Music/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Etherea.ogg",
                                  title  = _"Etherea",
                                  author = "ragesoss" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Final.ogg",
                                  title  = _"Final",
                                  author = "charly" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "In_the_Land_of_Madness.ogg",
                                  title  = _"In The Land Of Madness",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "Isanbar_Theme.ogg",
                                  title  = _"Isanbar Theme",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "LunarCage.ogg",
                                  title  = _"Lunar Cage",
                                  author = "AngeloB" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "March_of_the_divine.ogg",
                                  title  = _"March of the Divine",
                                  author = "greatsaiamanz@hotmail.com" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "a3deap_GoForTheWorldAgain.ogg",
                                  title  = _"Go for the World Again",
                                  author = "Novatlan" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "acherontic.ogg",
                                  title  = _"Acherontic",
                                  author = "x42" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ambuscade.ogg",
                                  title  = _"Ambuscade",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "battlecry.ogg",
                                  title  = _"Battle Cry",
                                  author = "ancestral" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "dark_passage.ogg",
                                  title  = _"Dark Passage",
                                  author = "West" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "end.ogg",
                                  title  = _"End",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "fragments_of_time_cut.ogg",
                                  title  = _"Fragments of Time (Cut)",
                                  author = "Erik Rijshouwer" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "gathering_storm.ogg",
                                  title  = _"The Gathering Storm",
                                  author = "Ewing" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "moleman.ogg",
                                  title  = _"MoleMan",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "northerners-old.ogg",
                                  title  = _"Northerners",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "overlive.ogg",
                                  title  = _"Overlive",
                                  author = "Telaron" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "sing.ogg",
                                  title  = _"Sing",
                                  author = "marcusvinicius" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "snowfall.ogg",
                                  title  = _"Lonely Snowfall",
                                  author = "jeremy2" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "tribal_war_song.ogg",
                                  title  = _"Primitive War Song",
                                  author = "hiro hito" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "wesnoth_song1.ogg",
                                  title  = _"Wesnoth Song",
                                  author = "Jarkko" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_archaic()
  local path = "~add-ons/Archaic_Sounds/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/Archaic_Sounds/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "FranticSketch.ogg",
                                  title  = _"Frantic Sketch",
                                  author = "TreizeCouleurs" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "In_the_Land_of_Madness.ogg",
                                  title  = _"In The Land Of Madness",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "New_Wesnoth_Battle_Music.ogg",
                                  title  = _"PS Sewers Battle Theme 5",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "One_Thousand_Suns.ogg",
                                  title  = _"One Thousand Suns",
                                  author = "Tyler Johnson" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "gathering_storm.ogg",
                                  title  = _"The Gathering Storm",
                                  author = "Ewing" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "northerners-classic.ogg",
                                  title  = _"Northerners",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "triumph.ogg",
                                  title  = _"?",
                                  author = "?" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_shadow_of_death()
  local path = "~add-ons/In_Shadow_music/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local music_path = "~add-ons/In_Shadow_music/music/"
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "heroic_march.ogg",
                                  title  = _"Beethoven: Eroica - 2nd Mvt.",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "isle_of_dead.ogg",
                                  title  = _"Rachmaninoff: Isle of the Dead",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "ragnarok.ogg",
                                  title  = "?",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "requiem1.ogg",
                                  title  = _"Brahms: A German Requiem - Denn alles Fleisch, es ist wie Gras",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "song_parks.ogg",
                                  title  = "?",
                                  author = "?" } )
    tamanegi_jukebox_add_track( ret, music_path,
                                { file   = "valkyries.ogg",
                                  title  = _"Wagner: Die Walküre",
                                  author = "?" } )
  end
  return ret
end

function tamanegi_jukebox_get_table_jukebox_music()
  local path = "~add-ons/Jukebox_Music/_main.cfg"
  local ret = {}
  if wesnoth.have_file( path ) then
    local playlists = wesnoth.read_file("~add-ons/Jukebox_Music/music/")
    for i=1,playlists.ndirs do
       local music_path = "~add-ons/Jukebox_Music/music/"
       for _, ogg_file in ipairs(wesnoth.read_file(music_path..playlists[i].."/")) do
         tamanegi_jukebox_add_track( ret,  music_path,
                                     { file   = playlists[i].."/"..ogg_file,
                                       title  = playlists[i],
                                       author = "?" } )
       end
    end
  end
  return ret
end
