local helper = wesnoth.require "lua/helper.lua"
_ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"
local utils = wesnoth.require "~add-ons/Tamanegi_Jukebox/lua/jukebox_utils.lua"
local jukebox = wesnoth.require "~add-ons/Tamanegi_Jukebox/lua/jukebox.lua"

function wesnoth.wml_actions.tj_jukebox(cfg)
  tj_gui_jukebox( tamanegi_jukebox_get_all_music_list() )
end

function wesnoth.wml_actions.tj_jukebox_package(cfg)
  tj_gui_jukebox_package()
end

function wesnoth.wml_actions.tj_launch_manager(cfg)
  local music_list = cfg.variable or helper.wml_error "[tj_launch_manager] requires variable= attribute."
  local title = _"Music list"
  if cfg.title then
    title = cfg.title
  end

  tj_wml_jukebox_manager( music_list, title )
end

function wesnoth.wml_actions.tj_launch_manager2(cfg)
  local music_list1 = cfg.variable1 or helper.wml_error "[tj_launch_manager2] requires variable1= attribute."
  local title1 = _"Music list1"
  if cfg.title1 then title1 = cfg.title1 end

  local music_list2 = cfg.variable2 or helper.wml_error "[tj_launch_manager2] requires variable2= attribute."
  local title2 = _"Music list2"
  if cfg.title2 then title2 = cfg.title2 end

  tj_wml_jukebox_manager2( music_list1, title1,
                           music_list2, title2 )
end

function wesnoth.wml_actions.tj_launch_manager3(cfg)
  local music_list1 = cfg.variable1 or helper.wml_error "[tj_launch_manager3] requires variable1= attribute."
  local title1 = _"Music list1"
  if cfg.title1 then title1 = cfg.title1 end

  local music_list2 = cfg.variable2 or helper.wml_error "[tj_launch_manager3] requires variable2= attribute."
  local title2 = _"Music list2"
  if cfg.title2 then title2 = cfg.title2 end

  local music_list3 = cfg.variable3 or helper.wml_error "[tj_launch_manager3] requires variable3= attribute."
  local title3 = _"Music list3"
  if cfg.title3 then title3 = cfg.title3 end

  tj_wml_jukebox_manager3( music_list1, title1,
                           music_list2, title2,
                           music_list3, title3 )
end

function wesnoth.wml_actions.tj_load_music(cfg)
  local music_list = cfg.variable or helper.wml_error "[tj_load_music] requires variable= attribute."

  tamanegi_jukebox_utility_reset_playlist(music_list)
end

function wesnoth.wml_actions.tj_add_track_fname(cfg)
  local music_list = cfg.variable or helper.wml_error "[tj_add_track_fname] requires variable= attribute."
  local reqlist = cfg.file or helper.wml_error "[tj_add_track_fname] requires file= attribute."
  local mylist = tamanegi_jukebox_get_all_music_list()

  reqlist = tj_split(",",reqlist)
  for i = 1, #reqlist do
    reqlist[i] = reqlist[i]:match "^%s*(.-)%s*$"
  end

  -- there must be smarter way...
  for i = 1, #mylist do
    for j = 1, #reqlist do
      if mylist[i].file == reqlist[j] then
        tamanegi_jukebox_utility_add_track( music_list, mylist[i] )
      end
    end
  end
end
