local helper = wesnoth.require "lua/helper.lua"
_ = wesnoth.textdomain "wesnoth-tamanegi_jukebox"

function tj_split(seps,str)
  local ret = {}
  local pos = 1

  -- default separator
  if #seps == 0 or not seps then
    seps = "%s+"
  end

  if string.find("",seps,1) then
    error("Invalid separators.")
  end

  while 1 do
    local first,second = string.find(str,seps,pos)
    if first then
      table.insert(ret,string.sub(str,pos,first-1))
      pos = second + 1
    else
      table.insert(ret,string.sub(str,pos))
      break
    end
  end
  return ret
end

function tj_current_music()
  if wesnoth.music_list == nil then
    return nil
  end

  if #wesnoth.music_list == 0 then
     return nil
  end

  -- if wesnoth.music_list.current_i == nil then
  --  return nil
  -- end

  return wesnoth.music_list.current.__cfg.name
end

-- Lifted from: Wesnoth_Music_Player
function tj_strip_path_and_ext(path)
  if path == nil then
    return "[none]"
  end

  local slash = string.find(path, "/[^/]*")
  if slash == nil then
    slash = 0
  end

  local file_name = string.sub(path, slash+1)

  local stripped_name = string.sub(file_name, 1, string.len(file_name)-4)
  if stripped_name == nil then
    return "[none]"
  end
  return stripped_name
end
